#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_run_after_forkers4xi.py">
#<abstract4xi abstract = "providing function _run_after_forkers4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_run_after_forkers4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import itertools
import weakref
import atexit
import logging
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from after_fork4xi import _afterfork_counter
from after_fork4xi import _afterfork_registry

from print4xi import print4xi
from time4xi import time4xi
#"
#/>




# -------------------------------------------------------------------------------------------------
#<function4xi function = "run-after-forkers4xi" usage = "
#   managers.py: 
#       util._run_after_forkers()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
def _run_after_forkers4xi():
    '''
    supports re-initialization of objects when bootstrapping a child process
    '''    

    # -----------------------------------------------------------------------------------------    
    # (Step 1/7)
    # -----------------------------------------------------------------------------------------       
    
    class2print = "_run_after_forkers4xi"
    method2print = "_run_after_forkers4xi"
    
    
    message2print = "{(Step 1/7) started" + "; run-after-forkers4xi-started: " + str(_run_after_forkers4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
      
    
    # -----------------------------------------------------------------------------------------    
    # (Step 2/7)
    # -----------------------------------------------------------------------------------------        
    items = list(_afterfork_registry.items())
    
    message2print = "{(Step 2/7) set" + "; items-set-by-run-after-forkers4xi to: " + str(items)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
    
    # -----------------------------------------------------------------------------------------    
    # (Step 3/7)
    # -----------------------------------------------------------------------------------------       
    
    items.sort()
    
    message2print = "{(Step 3/7) performed" + "; items-sort-performed-by-run-after-forkers4xi: " + str(items.sort) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
                
    
    # -----------------------------------------------------------------------------------------    
    # (Step 4/7)
    # -----------------------------------------------------------------------------------------       
    for (index, ident, func), obj in items:
    
        message2print = "{(Step 4/7a) got" + "; index-got-by-run-after-forkers4xi: " + str(index)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{(Step 4/7b) got" + "; ident-got-by-run-after-forkers4xi: " + str(ident)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{(Step 4/7c) got" + "; func-got-by-run-after-forkers4xi: " + str(func)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{(Step 4/7d) got" + "; object-got-by-run-after-forkers4xi: " + str(obj)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                            
        
        try:
            
            
            # ---------------------------------------------------------------------------------    
            # (Step 5/7)
            # ---------------------------------------------------------------------------------         
            message2print = "{(Step 5/7a) passing" + "; object-passing-to-func-by-run-after-forkers4xi: " + str(obj) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
         
      
        
            func(obj)
            
            message2print = "{(Step 5/7b) performed" + "; func-performed-by-run-after-forkers4xi: " + str(func) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                       
      
            
        except Exception as e:

            
            # ---------------------------------------------------------------------------------    
            # (Step 6/7)
            # ---------------------------------------------------------------------------------         
            info4xi('_run_after_forkers4xi: after forker raised exception %s', e)
            
            message2print = "{(Step 6/7) hit" + "; Exception-hit-by-run-after-forkers4xi: " + " *** " + str(e)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                    
                    
         
            
    # -----------------------------------------------------------------------------------------    
    # (Step 7/7)
    # -----------------------------------------------------------------------------------------                   
    message2print = "{(Step 7/7) returning" + "; run-after-forkers4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                   
#</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_run_after_forkers4xi.txt
#   sense-test-run-after-forkers4xi.xml
#   reason-test-run-after-forkers4xi.xml
#   ace-test-run-after-forkers4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _run_after_forkers4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
              